## bup 0.29

=== Makefile ===

SHELL := bash
.DEFAULT_GOAL := all

# See config/config.vars.in (sets bup_python, among other things)
include config/config.vars

pf := set -o pipefail

define isok
  && echo " ok" || echo " no"
endef

# If ok, strip trailing " ok" and return the output, otherwise, error
define shout
$(if $(subst ok,,$(lastword $(1))),$(error $(2)),$(shell x="$(1)"; echo $${x%???}))
endef

sampledata_rev := $(shell t/configure-sampledata --revision $(isok))
sampledata_rev := \
  $(call shout,$(sampledata_rev),Could not parse sampledata revision)

current_sampledata := t/sampledata/var/rev/v$(sampledata_rev)

os := $(shell ($(pf); uname | sed 's/[-_].*//') $(isok))
os := $(call shout,$(os),Unable to determine OS)

CFLAGS := -Wall -O2 -Werror -Wno-unknown-pragmas $(PYINCLUDE) $(CFLAGS)
CFLAGS := -D_FILE_OFFSET_BITS=64 $(CFLAGS)
SOEXT:=.so

ifeq ($(os),CYGWIN)
  SOEXT:=.dll
endif

ifdef TMPDIR
  test_tmp := $(TMPDIR)
else
  test_tmp := $(CURDIR)/t/tmp
endif

initial_setup := $(shell ./configure-version --update $(isok))
initial_setup := $(call shout,$(initial_setup),Version configuration failed))

config/config.vars: configure config/configure config/configure.inc \
  $(wildcard config/*.in)
	MAKE="$(MAKE)" ./configure

bup_cmds := cmd/bup-python\
  $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py)) \
  $(patsubst cmd/%-cmd.sh,cmd/bup-%,$(wildcard cmd/*-cmd.sh))

bup_deps := bup lib/bup/_checkout.py lib/bup/_helpers$(SOEXT) $(bup_cmds)

all: $(bup_deps) Documentation/all $(current_sampledata)

bup:
	ln -s main.py bup

$(current_sampledata):
	t/configure-sampledata --setup

define install-python-bin
  set -e; \
  sed -e '1 s|.*|#!$(bup_python)|; 2,/^# end of bup preamble$$/d' $1 > $2; \
  chmod 0755 $2;
endef

PANDOC ?= $(shell type -p pandoc)

ifeq (,$(PANDOC))
  $(shell echo "Warning: pandoc not found; skipping manpage generation" 1>&2)
  man_md :=
else
  man_md := $(wildcard Documentation/*.md)
endif

man_roff := $(patsubst %.md,%.1,$(man_md))
man_html := $(patsubst %.md,%.html,$(man_md))

INSTALL=install
PREFIX=/usr/local
MANDIR=$(PREFIX)/share/man
DOCDIR=$(PREFIX)/share/doc/bup
BINDIR=$(PREFIX)/bin
LIBDIR=$(PREFIX)/lib/bup

dest_mandir := $(DESTDIR)$(MANDIR)
dest_docdir := $(DESTDIR)$(DOCDIR)
dest_bindir := $(DESTDIR)$(BINDIR)
dest_libdir := $(DESTDIR)$(LIBDIR)

install: all
	$(INSTALL) -d $(dest_bindir) \
		$(dest_libdir)/bup $(dest_libdir)/cmd \
		$(dest_libdir)/web $(dest_libdir)/web/static
	test -z "$(man_roff)" || install -d $(dest_mandir)/man1
	test -z "$(man_roff)" || $(INSTALL) -m 0644 $(man_roff) $(dest_mandir)/man1
	test -z "$(man_html)" || install -d $(dest_docdir)
	test -z "$(man_html)" || $(INSTALL) -m 0644 $(man_html) $(dest_docdir)
	$(call install-python-bin,bup,"$(dest_bindir)/bup")
	set -e; \
	for cmd in $$(ls cmd/bup-* | grep -v cmd/bup-python); do \
	  $(call install-python-bin,"$$cmd","$(dest_libdir)/$$cmd") \
	done
	$(INSTALL) -pm 0644 \
		lib/bup/*.py \
		$(dest_libdir)/bup
	$(INSTALL) -pm 0755 \
		lib/bup/*$(SOEXT) \
		$(dest_libdir)/bup
	$(INSTALL) -pm 0644 \
		lib/web/static/* \
		$(dest_libdir)/web/static/
	$(INSTALL) -pm 0644 \
		lib/web/*.html \
		$(dest_libdir)/web/

config/config.h: config/config.vars

lib/bup/_helpers$(SOEXT): \
		config/config.h \
		lib/bup/bupsplit.c lib/bup/_helpers.c lib/bup/csetup.py
	@rm -f $@
	cd lib/bup && \
	LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" "$(bup_python)" csetup.py build
	cp lib/bup/build/*/_helpers$(SOEXT) lib/bup/

lib/bup/_checkout.py:
	@if grep -F '$Format' lib/bup/_release.py \
	    && ! test -e lib/bup/_checkout.py; then \
	  echo "Something has gone wrong; $@ should already exist."; \
	  echo 'Check "./configure-version --update"'; \
	  false; \
	fi

t/tmp:
	mkdir t/tmp

runtests: runtests-python runtests-cmdline

# The "pwd -P" here may not be appropriate in the long run, but we
# need it until we settle the relevant drecurse/exclusion questions:
# https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
runtests-python: all t/tmp
	$(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
	  "$(bup_python)" wvtest.py t/t*.py lib/*/t/t*.py 2>&1 \
	    | tee -a t/tmp/test-log/$$$$.log

cmdline_tests := \
  t/test-prune-older \
  t/test-web.sh \
  t/test-rm.sh \
  t/test-gc.sh \
  t/test-main.sh \
  t/test-list-idx.sh \
  t/test-index.sh \
  t/test-split-join.sh \
  t/test-fuse.sh \
  t/test-drecurse.sh \
  t/test-cat-file.sh \
  t/test-compression.sh \
  t/test-fsck.sh \
  t/test-index-clear.sh \
  t/test-index-check-device.sh \
  t/test-ls.sh \
  t/test-tz.sh \
  t/test-meta.sh \
  t/test-on.sh \
  t/test-restore-map-owner.sh \
  t/test-restore-single-file.sh \
  t/test-rm-between-index-and-save.sh \
  t/test-save-with-valid-parent.sh \
  t/test-sparse-files.sh \
  t/test-command-without-init-fails.sh \
  t/test-redundant-saves.sh \
  t/test-save-creates-no-unrefs.sh \
  t/test-save-restore-excludes.sh \
  t/test-save-strip-graft.sh \
  t/test-import-duplicity.sh \
  t/test-import-rdiff-backup.sh \
  t/test-xdev.sh \
  t/test.sh

# For parallel runs.
# The "pwd -P" here may not be appropriate in the long run, but we
# need it until we settle the relevant drecurse/exclusion questions:
# https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
tmp-target-run-test%: all t/tmp
	$(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
	  t/test$* 2>&1 | tee -a t/tmp/test-log/$$$$.log

runtests-cmdline: $(subst t/test,tmp-target-run-test,$(cmdline_tests))

stupid:
	PATH=/bin:/usr/bin $(MAKE) test

test: all
	if test -e t/tmp/test-log; then rm -r t/tmp/test-log; fi
	mkdir -p t/tmp/test-log
	./wvtest watch --no-counts \
	  $(MAKE) runtests-python runtests-cmdline 2>t/tmp/test-log/$$$$.log
	./wvtest report t/tmp/test-log/*.log

check: test

distcheck: all
	./wvtest run t/test-release-archive.sh

cmd/python-cmd.sh: config/config.vars Makefile
	printf "#!/bin/sh\nexec %q \"\$$@\"" "$(bup_python)" \
	  >> cmd/python-cmd.sh.$$PPID.tmp
	chmod +x cmd/python-cmd.sh.$$PPID.tmp
	mv cmd/python-cmd.sh.$$PPID.tmp cmd/python-cmd.sh

cmd/bup-%: cmd/%-cmd.py
	rm -f $@
	ln -s $*-cmd.py $@

cmd/bup-%: cmd/%-cmd.sh
	rm -f $@
	ln -s $*-cmd.sh $@

.PHONY: Documentation/all
Documentation/all: $(man_roff) $(man_html)

Documentation/substvars: $(bup_deps)
	echo "s,%BUP_VERSION%,$$(./bup version --tag),g" > $@
	echo "s,%BUP_DATE%,$$(./bup version --date),g" >> $@

Documentation/%.1: Documentation/%.md Documentation/substvars
	$(pf); sed -f Documentation/substvars $< \
	  | $(PANDOC) -s -r markdown -w man -o $@

Documentation/%.html: Documentation/%.md Documentation/substvars
	$(pf); sed -f Documentation/substvars $< \
	  | $(PANDOC) -s -r markdown -w html -o $@

.PHONY: Documentation/clean
Documentation/clean:
	cd Documentation && rm -f *~ .*~ *.[0-9] *.html substvars

# update the local 'man' and 'html' branches with pregenerated output files, for
# people who don't have pandoc (and maybe to aid in google searches or something)
export-docs: Documentation/all
	git update-ref refs/heads/man origin/man '' 2>/dev/null || true
	git update-ref refs/heads/html origin/html '' 2>/dev/null || true
	set -eo pipefail; \
	GIT_INDEX_FILE=gitindex.tmp; export GIT_INDEX_FILE; \
	rm -f $${GIT_INDEX_FILE} && \
	git add -f Documentation/*.1 && \
	git update-ref refs/heads/man \
		$$(echo "Autogenerated man pages for $$(git describe --always)" \
		    | git commit-tree $$(git write-tree --prefix=Documentation) \
				-p refs/heads/man) && \
	rm -f $${GIT_INDEX_FILE} && \
	git add -f Documentation/*.html && \
	git update-ref refs/heads/html \
		$$(echo "Autogenerated html pages for $$(git describe --always)" \
		    | git commit-tree $$(git write-tree --prefix=Documentation) \
				-p refs/heads/html)

# push the pregenerated doc files to origin/man and origin/html
push-docs: export-docs
	git push origin man html

# import pregenerated doc files from origin/man and origin/html, in case you
# don't have pandoc but still want to be able to install the docs.
import-docs: Documentation/clean
	$(pf); git archive origin/html | (cd Documentation && tar -xvf -)
	$(pf); git archive origin/man | (cd Documentation && tar -xvf -)

clean: Documentation/clean cmd/bup-python
	cd config && rm -f *~ .*~ \
	  ${CONFIGURE_DETRITUS} ${CONFIGURE_FILES} ${GENERATED_FILES}
	rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
		.*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
		*.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
		bup bup-* \
		randomgen memtest \
		testfs.img lib/bup/t/testfs.img
	if test -e t/mnt; then t/cleanup-mounts-under t/mnt; fi
	if test -e t/mnt; then rm -r t/mnt; fi
	if test -e t/tmp; then t/cleanup-mounts-under t/tmp; fi
        # FIXME: migrate these to t/mnt/
	if test -e lib/bup/t/testfs; \
	  then umount lib/bup/t/testfs || true; fi
	rm -rf *.tmp *.tmp.meta t/*.tmp lib/*/*/*.tmp build lib/bup/build lib/bup/t/testfs
	if test -e t/tmp; then t/force-delete t/tmp; fi
	./configure-version --clean
	t/configure-sampledata --clean
        # Remove last so that cleanup tools can depend on it
	rm -f cmd/bup-* cmd/python-cmd.sh

=== debian/changelog ===
bup (0.29-3) unstable; urgency=medium

  [ Tim Riemenschneider ]
  * Safeguard against deleting new pack-file (f.e. with threshold=0)
    (Closes: #859295)

 -- Robert Edmonds <edmonds@debian.org>  Sat, 01 Apr 2017 14:38:19 -0400

bup (0.29-2) unstable; urgency=medium

  [ James Cowgill ]
  * Build-Depend on tzdata to fix FTBFS. (Closes: #839498)

  [ Robert Edmonds ]
  * debian/changelog: Acknowledge 0.28.1-1.1 NMU

 -- Robert Edmonds <edmonds@debian.org>  Sun, 01 Jan 2017 14:42:37 -0500

bup (0.29-1) unstable; urgency=medium

  * New upstream version 0.29
  * debian/control: Upgrade Vcs-Git URL from git:// to https://
  * debian/control: Bump Standards-Version to 3.9.8 (no changes)

 -- Robert Edmonds <edmonds@debian.org>  Thu, 29 Dec 2016 16:08:15 -0500

bup (0.29~rc1-1) experimental; urgency=medium

  [ Rob Browning ]
  * test-prune-older: set test git author/committer

  [ Robert Edmonds ]
  * New upstream version 0.29-rc1

 -- Robert Edmonds <edmonds@debian.org>  Sat, 24 Dec 2016 14:13:27 -0500

bup (0.28.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-Depend on tzdata to fix FTBFS. (Closes: #839498)

 -- James Cowgill <jcowgill@debian.org>  Thu, 27 Oct 2016 15:22:29 +0100

bup (0.28.1-1) unstable; urgency=medium

  * New upstream version 0.28.1
  * debian/rules: Generate our own /usr/lib/bup/bup/_release.py
  * cmd/version-cmd.py: Disable regex test for tag names

 -- Robert Edmonds <edmonds@debian.org>  Sun, 02 Oct 2016 17:22:52 -0400

bup (0.28~rc3-1) experimental; urgency=medium

  * New upstream release.

 -- Robert Edmonds <edmonds@debian.org>  Sat, 21 May 2016 23:49:48 -0400

=== debian/control ===
Source: bup
Section: admin
Priority: extra
Maintainer: Robert Edmonds <edmonds@debian.org>
Build-Depends:
 dctrl-tools,
 debhelper (>= 9~),
 dh-python,
 git,
 par2 [!hurd-i386],
 python-dev (>= 2.6.6-3~),
 python-pylibacl,
 python-pyxattr [linux-any],
 rsync,
 tzdata,
Build-Depends-Indep: pandoc (>= 1.11.1-4~), pandoc-data (>= 1.11.1-4~)
Standards-Version: 3.9.8
Homepage: https://github.com/bup/bup
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/bup.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/bup.git

Package: bup
Architecture: any
Depends:
 git,
 par2 [!hurd-i386],
 python,
 python-pylibacl,
 python-pyxattr [linux-any],
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
Recommends: bup-doc, python-fuse, python-tornado
Description: highly efficient file backup system based on git
 bup is a backup tool which stores the backups in a system based around
 the packfile format from git.

Package: bup-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Breaks: bup (<< 0.25~rc2-2~)
Replaces: bup (<< 0.25~rc2-2~)
Description: highly efficient file backup system based on git (documentation)
 bup is a backup tool which stores the backups in a system based around
 the packfile format from git.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2

override_dh_auto_configure:
	./configure

override_dh_auto_build-indep:
	$(MAKE) Documentation/all

override_dh_auto_clean:
	-rm config/config.cmd config/config.h config/config.log config/config.mak config/config.md config/config.sub config/config.vars
	dh_auto_clean

override_dh_auto_install:
	$(MAKE) PREFIX="/usr" DESTDIR="$(CURDIR)/debian/tmp" install
	$(CURDIR)/debian/gen_version_py.sh > $(CURDIR)/debian/tmp/usr/lib/bup/bup/_release.py

## bup 0.29.3

=== Makefile ===
--- 
+++ 
@@ -62,8 +62,12 @@
 
 define install-python-bin
   set -e; \
-  sed -e '1 s|.*|#!$(bup_python)|; 2,/^# end of bup preamble$$/d' $1 > $2; \
-  chmod 0755 $2;
+  if grep -qE '^# end of bup preamble$$' "$1"; then \
+    sed -E '1 s|.*|#!$(bup_python)|; 2,/^# end of bup preamble$$/d' $(1) > $(2); \
+  else \
+    cp $(1) $(2); \
+  fi; \
+  chmod 0755 $(2);
 endef
 
 PANDOC ?= $(shell type -p pandoc)
@@ -240,25 +244,12 @@
 Documentation/clean:
 	cd Documentation && rm -f *~ .*~ *.[0-9] *.html substvars
 
-# update the local 'man' and 'html' branches with pregenerated output files, for
-# people who don't have pandoc (and maybe to aid in google searches or something)
-export-docs: Documentation/all
-	git update-ref refs/heads/man origin/man '' 2>/dev/null || true
-	git update-ref refs/heads/html origin/html '' 2>/dev/null || true
-	set -eo pipefail; \
-	GIT_INDEX_FILE=gitindex.tmp; export GIT_INDEX_FILE; \
-	rm -f $${GIT_INDEX_FILE} && \
-	git add -f Documentation/*.1 && \
-	git update-ref refs/heads/man \
-		$$(echo "Autogenerated man pages for $$(git describe --always)" \
-		    | git commit-tree $$(git write-tree --prefix=Documentation) \
-				-p refs/heads/man) && \
-	rm -f $${GIT_INDEX_FILE} && \
-	git add -f Documentation/*.html && \
-	git update-ref refs/heads/html \
-		$$(echo "Autogenerated html pages for $$(git describe --always)" \
-		    | git commit-tree $$(git write-tree --prefix=Documentation) \
-				-p refs/heads/html)
+# Note: this adds commits containing the current manpages in roff and
+# html format to the man and html branches respectively.  The version
+# is determined by "git describe --always".
+.PHONY: update-doc-branches
+update-doc-branches: Documentation/all
+	dev/update-doc-branches refs/heads/man refs/heads/html
 
 # push the pregenerated doc files to origin/man and origin/html
 push-docs: export-docs

## bup 0.31

=== Makefile ===

MAKEFLAGS += --warn-undefined-variables

SHELL := bash
.DEFAULT_GOAL := all

# See config/config.vars.in (sets bup_python, among other things)
-include config/config.vars

pf := set -o pipefail
cfg_py := $(CURDIR)/config/bin/python

define isok
  && echo " ok" || echo " no"
endef

# If ok, strip trailing " ok" and return the output, otherwise, error
define shout
$(if $(subst ok,,$(lastword $(1))),$(error $(2)),$(shell x="$(1)"; echo $${x%???}))
endef

sampledata_rev := $(shell t/configure-sampledata --revision $(isok))
sampledata_rev := \
  $(call shout,$(sampledata_rev),Could not parse sampledata revision)

current_sampledata := t/sampledata/var/rev/v$(sampledata_rev)

os := $(shell ($(pf); uname | sed 's/[-_].*//') $(isok))
os := $(call shout,$(os),Unable to determine OS)

CFLAGS := -Wall -Wformat=2 -O2 -Werror -Wno-unknown-pragmas $(CFLAGS)
CFLAGS := -D_FILE_OFFSET_BITS=64 $(PYINCLUDE) $(CFLAGS)
SOEXT:=.so

ifeq ($(os),CYGWIN)
  SOEXT:=.dll
endif

ifdef TMPDIR
  test_tmp := $(TMPDIR)
else
  test_tmp := $(CURDIR)/t/tmp
endif

initial_setup := $(shell dev/update-checkout-info lib/bup/checkout_info.py $(isok))
initial_setup := $(call shout,$(initial_setup),update-checkout-info failed))

config/config.vars: \
  configure config/configure config/configure.inc \
  $(wildcard config/*.in)
	MAKE="$(MAKE)" ./configure

# On some platforms, Python.h and readline.h fight over the
# _XOPEN_SOURCE version, i.e. -Werror crashes on a mismatch, so for
# now, we're just going to let Python's version win.

ifneq ($(strip $(bup_readline_cflags)),)
  readline_cflags += $(bup_readline_cflags)
  readline_xopen := $(filter -D_XOPEN_SOURCE=%,$(readline_cflags))
  readline_xopen := $(subst -D_XOPEN_SOURCE=,,$(readline_xopen))
  readline_cflags := $(filter-out -D_XOPEN_SOURCE=%,$(readline_cflags))
  readline_cflags += $(addprefix -DBUP_RL_EXPECTED_XOPEN_SOURCE=,$(readline_xopen))
  CFLAGS += $(readline_cflags)
endif

LDFLAGS += $(bup_readline_ldflags)

ifeq ($(bup_have_libacl),1)
  CFLAGS += $(bup_libacl_cflags)
  LDFLAGS += $(bup_libacl_ldflags)
endif

config/bin/python: config/config.vars

bup_cmds := \
  $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py)) \
  $(patsubst cmd/%-cmd.sh,cmd/bup-%,$(wildcard cmd/*-cmd.sh))

bup_deps := lib/bup/_helpers$(SOEXT) $(bup_cmds)

all: $(bup_deps) Documentation/all $(current_sampledata)

$(current_sampledata):
	t/configure-sampledata --setup

PANDOC ?= $(shell type -p pandoc)

ifeq (,$(PANDOC))
  $(shell echo "Warning: pandoc not found; skipping manpage generation" 1>&2)
  man_md :=
else
  man_md := $(wildcard Documentation/*.md)
endif

man_roff := $(patsubst %.md,%.1,$(man_md))
man_html := $(patsubst %.md,%.html,$(man_md))

INSTALL=install
PREFIX=/usr/local
MANDIR=$(PREFIX)/share/man
DOCDIR=$(PREFIX)/share/doc/bup
BINDIR=$(PREFIX)/bin
LIBDIR=$(PREFIX)/lib/bup

dest_mandir := $(DESTDIR)$(MANDIR)
dest_docdir := $(DESTDIR)$(DOCDIR)
dest_bindir := $(DESTDIR)$(BINDIR)
dest_libdir := $(DESTDIR)$(LIBDIR)

install: all
	$(INSTALL) -d $(dest_bindir) \
		$(dest_libdir)/bup $(dest_libdir)/cmd \
		$(dest_libdir)/web $(dest_libdir)/web/static
	test -z "$(man_roff)" || install -d $(dest_mandir)/man1
	test -z "$(man_roff)" || $(INSTALL) -m 0644 $(man_roff) $(dest_mandir)/man1
	test -z "$(man_html)" || install -d $(dest_docdir)
	test -z "$(man_html)" || $(INSTALL) -m 0644 $(man_html) $(dest_docdir)
	dev/install-python-script lib/cmd/bup "$(dest_libdir)/cmd/bup"
	set -e; \
	for cmd in $$(ls cmd/bup-*); do \
	  dev/install-python-script "$$cmd" "$(dest_libdir)/$$cmd"; \
	done
	cd "$(dest_bindir)" && \
	  ln -sf "$$($(bup_python) -c 'import os; print(os.path.relpath("$(abspath $(dest_libdir))/cmd/bup"))')"
	set -e; \
	$(INSTALL) -pm 0644 \
		lib/bup/*.py \
		$(dest_libdir)/bup
	$(INSTALL) -pm 0755 \
		lib/bup/*$(SOEXT) \
		$(dest_libdir)/bup
	$(INSTALL) -pm 0644 \
		lib/web/static/* \
		$(dest_libdir)/web/static/
	$(INSTALL) -pm 0644 \
		lib/web/*.html \
		$(dest_libdir)/web/
	if test -e lib/bup/checkout_info.py; then \
	    $(INSTALL) -pm 0644 lib/bup/checkout_info.py \
	        $(dest_libdir)/bup/source_info.py; \
	else \
	    ! grep -qF '$$Format' lib/bup/source_info.py; \
	    $(INSTALL) -pm 0644 lib/bup/source_info.py $(dest_libdir)/bup/; \
	fi

config/config.h: config/config.vars

lib/bup/_helpers$(SOEXT): \
		config/config.h lib/bup/bupsplit.h \
		lib/bup/bupsplit.c lib/bup/_helpers.c lib/bup/csetup.py
	@rm -f $@
	cd lib/bup && $(cfg_py) csetup.py build "$(CFLAGS)" "$(LDFLAGS)"
        # Make sure there's just the one file we expect before we copy it.
	$(cfg_py) -c \
	  "import glob; assert(len(glob.glob('lib/bup/build/*/_helpers*$(SOEXT)')) == 1)"
	cp lib/bup/build/*/_helpers*$(SOEXT) "$@"

t/tmp:
	mkdir t/tmp

runtests: runtests-python runtests-cmdline

python_tests := \
  lib/bup/t/tbloom.py \
  lib/bup/t/tclient.py \
  lib/bup/t/tgit.py \
  lib/bup/t/thashsplit.py \
  lib/bup/t/thelpers.py \
  lib/bup/t/tindex.py \
  lib/bup/t/tmetadata.py \
  lib/bup/t/toptions.py \
  lib/bup/t/tresolve.py \
  lib/bup/t/tshquote.py \
  lib/bup/t/tvfs.py \
  lib/bup/t/tvint.py \
  lib/bup/t/txstat.py

# The "pwd -P" here may not be appropriate in the long run, but we
# need it until we settle the relevant drecurse/exclusion questions:
# https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
runtests-python: all t/tmp
	mkdir -p t/tmp/test-log
	$(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
	  ./wvtest.py  $(python_tests) 2>&1 \
	    | tee -a t/tmp/test-log/$$$$.log

cmdline_tests := \
  t/test-help \
  t/test.sh \
  t/test-argv \
  t/test-cat-file.sh \
  t/test-command-without-init-fails.sh \
  t/test-compression.sh \
  t/test-drecurse.sh \
  t/test-fsck.sh \
  t/test-fuse.sh \
  t/test-ftp \
  t/test-web.sh \
  t/test-gc.sh \
  t/test-import-duplicity.sh \
  t/test-import-rdiff-backup.sh \
  t/test-index.sh \
  t/test-index-check-device.sh \
  t/test-index-clear.sh \
  t/test-list-idx.sh \
  t/test-ls \
  t/test-ls-remote \
  t/test-main.sh \
  t/test-meta.sh \
  t/test-on.sh \
  t/test-packsizelimit \
  t/test-prune-older \
  t/test-redundant-saves.sh \
  t/test-restore-map-owner.sh \
  t/test-restore-single-file.sh \
  t/test-rm.sh \
  t/test-rm-between-index-and-save.sh \
  t/test-save-creates-no-unrefs.sh \
  t/test-save-restore \
  t/test-save-errors \
  t/test-save-restore-excludes.sh \
  t/test-save-strip-graft.sh \
  t/test-save-with-valid-parent.sh \
  t/test-sparse-files.sh \
  t/test-split-join.sh \
  t/test-tz.sh \
  t/test-xdev.sh

tmp-target-run-test-get-%: all t/tmp
	$(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
	  t/test-get $* 2>&1 | tee -a t/tmp/test-log/$$$$.log

test_get_targets += \
  tmp-target-run-test-get-replace \
  tmp-target-run-test-get-universal \
  tmp-target-run-test-get-ff \
  tmp-target-run-test-get-append \
  tmp-target-run-test-get-pick \
  tmp-target-run-test-get-new-tag \
  tmp-target-run-test-get-unnamed

# For parallel runs.
# The "pwd -P" here may not be appropriate in the long run, but we
# need it until we settle the relevant drecurse/exclusion questions:
# https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
tmp-target-run-test%: all t/tmp
	$(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
	  t/test$* 2>&1 | tee -a t/tmp/test-log/$$$$.log

runtests-cmdline: $(test_get_targets) $(subst t/test,tmp-target-run-test,$(cmdline_tests))

stupid:
	PATH=/bin:/usr/bin $(MAKE) test

test: all
	if test -e t/tmp/test-log; then rm -r t/tmp/test-log; fi
	mkdir -p t/tmp/test-log
	./wvtest watch --no-counts \
	  $(MAKE) runtests 2>t/tmp/test-log/$$$$.log
	./wvtest report t/tmp/test-log/*.log

check: test

distcheck: all
	./wvtest run t/test-release-archive.sh

long-test: export BUP_TEST_LEVEL=11
long-test: test

long-check: export BUP_TEST_LEVEL=11
long-check: check

.PHONY: check-both
check-both:
	$(MAKE) clean && PYTHON=python3 $(MAKE) check
	$(MAKE) clean && PYTHON=python2 $(MAKE) check

cmd/bup-%: cmd/%-cmd.py
	rm -f $@
	ln -s $*-cmd.py $@

cmd/bup-%: cmd/%-cmd.sh
	rm -f $@
	ln -s $*-cmd.sh $@

.PHONY: Documentation/all
Documentation/all: $(man_roff) $(man_html)

Documentation/substvars: $(bup_deps)
	echo "s,%BUP_VERSION%,$$(./bup version),g" > $@
	echo "s,%BUP_DATE%,$$(./bup version --date),g" >> $@

Documentation/%.1: Documentation/%.md Documentation/substvars
	$(pf); sed -f Documentation/substvars $< \
	  | $(PANDOC) -s -r markdown -w man -o $@

Documentation/%.html: Documentation/%.md Documentation/substvars
	$(pf); sed -f Documentation/substvars $< \
	  | $(PANDOC) -s -r markdown -w html -o $@

.PHONY: Documentation/clean
Documentation/clean:
	cd Documentation && rm -f *~ .*~ *.[0-9] *.html substvars

# Note: this adds commits containing the current manpages in roff and
# html format to the man and html branches respectively.  The version
# is determined by "git describe --always".
.PHONY: update-doc-branches
update-doc-branches: Documentation/all
	dev/update-doc-branches refs/heads/man refs/heads/html

# push the pregenerated doc files to origin/man and origin/html
push-docs: export-docs
	git push origin man html

# import pregenerated doc files from origin/man and origin/html, in case you
# don't have pandoc but still want to be able to install the docs.
import-docs: Documentation/clean
	$(pf); git archive origin/html | (cd Documentation && tar -xvf -)
	$(pf); git archive origin/man | (cd Documentation && tar -xvf -)

clean: Documentation/clean config/bin/python
	cd config && rm -rf config.var
	cd config && rm -f *~ .*~ \
	  ${CONFIGURE_DETRITUS} ${CONFIGURE_FILES} ${GENERATED_FILES}
	rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
		.*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
		*.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
		lib/bup/checkout_info.py \
		randomgen memtest \
		testfs.img lib/bup/t/testfs.img
	for x in $$(ls cmd/*-cmd.py cmd/*-cmd.sh | grep -vF python-cmd.sh | cut -b 5-); do \
	    echo "cmd/bup-$${x%-cmd.*}"; \
	done | xargs -t rm -f
	if test -e t/mnt; then t/cleanup-mounts-under t/mnt; fi
	if test -e t/mnt; then rm -r t/mnt; fi
	if test -e t/tmp; then t/cleanup-mounts-under t/tmp; fi
        # FIXME: migrate these to t/mnt/
	if test -e lib/bup/t/testfs; \
	  then umount lib/bup/t/testfs || true; fi
	rm -rf *.tmp *.tmp.meta t/*.tmp lib/*/*/*.tmp build lib/bup/build lib/bup/t/testfs
	if test -e t/tmp; then t/force-delete t/tmp; fi
	t/configure-sampledata --clean
        # Remove last so that cleanup tools can depend on it
	rm -rf config/bin

=== debian/changelog ===
bup (0.31-1) unstable; urgency=medium

  * New upstream version 0.31 (Closes: #961447)

 -- Robert Edmonds <edmonds@debian.org>  Sun, 23 Aug 2020 19:51:37 -0400

bup (0.31~git20200814-1) experimental; urgency=medium

  * New upstream git snapshot of commit
    3d243e3af895031e4a51113df9b7c51e09792347

 -- Robert Edmonds <edmonds@debian.org>  Fri, 14 Aug 2020 23:10:19 -0400

bup (0.31~git20200809-1) experimental; urgency=medium

  * New upstream git snapshot of commit
    07f74364b1854810f814e81e73822f35b7677318
  * debian/control: Update bup package's Recommends: python3-fuse,
    python3-tornado

 -- Robert Edmonds <edmonds@debian.org>  Sun, 09 Aug 2020 15:23:24 -0400

bup (0.31~git20200808-1) experimental; urgency=medium

  * New upstream git snapshot of commit
    ba836360f66ed046be1af98904a36a4ce862ca62
  * debian/rules: Exclude py2raise.py from byte-compilation; it is not
    syntactically valid Python 3
  * debian/control: Bump Standards-Version to 4.5.0 (no changes)
  * debian/: Bump debhelper compat level to 13

 -- Robert Edmonds <edmonds@debian.org>  Sat, 08 Aug 2020 21:28:59 -0400

bup (0.31~git20200728-1) experimental; urgency=medium

  * New upstream git snapshot due to call for testing
  * debian/: Remove debian/gen_version_py.sh due to upstream changes
  * debian/: Update dependencies and build rules for python3
    (Closes: #936251, #966723)
  * debian/control: Add additional build dependencies acl, libacl1-dev,
    libreadline-dev
  * debian/: Generate lib/bup/source_info.py
  * dev/install-python-script: Use Python 3

 -- Robert Edmonds <edmonds@debian.org>  Wed, 05 Aug 2020 02:39:00 -0400

bup (0.29.3-2) unstable; urgency=medium

  * Upload to unstable.

 -- Robert Edmonds <edmonds@debian.org>  Mon, 26 Aug 2019 11:24:25 -0400

bup (0.29.3-1) experimental; urgency=medium

  * New upstream version 0.29.3

 -- Robert Edmonds <edmonds@debian.org>  Sun, 25 Aug 2019 23:37:44 -0400

bup (0.29.2-1) experimental; urgency=medium

  * New upstream version 0.29.2
    - Contains test suite fix for newer versions of git. (Closes: #879213)
  * debian/control: Remove Vcs-Browser, Vcs-Git fields pointing to
    anonscm.debian.org
  * debian/control: Change package priority from extra to optional
  * debian/control: Mark bup-doc as "Multi-Arch: foreign"

 -- Robert Edmonds <edmonds@debian.org>  Sat, 17 Aug 2019 17:34:47 -0400

=== debian/control ===
Source: bup
Section: admin
Priority: optional
Maintainer: Robert Edmonds <edmonds@debian.org>
Build-Depends:
 acl,
 dctrl-tools,
 debhelper-compat (= 13),
 dh-python,
 git,
 libacl1-dev,
 libreadline-dev,
 par2 [!hurd-i386],
 python3-dev,
 python3-pylibacl,
 python3-pyxattr [linux-any],
 rsync,
 tzdata,
Build-Depends-Indep: pandoc (>= 1.11.1-4~), pandoc-data (>= 1.11.1-4~)
Standards-Version: 4.5.0
Homepage: https://github.com/bup/bup

Package: bup
Architecture: any
Depends:
 git,
 par2 [!hurd-i386],
 python3,
 python3-pylibacl,
 python3-pyxattr [linux-any],
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends: bup-doc, python3-fuse, python3-tornado
Description: highly efficient file backup system based on git
 bup is a backup tool which stores the backups in a system based around
 the packfile format from git.

Package: bup-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: bup (<< 0.25~rc2-2~)
Replaces: bup (<< 0.25~rc2-2~)
Description: highly efficient file backup system based on git (documentation)
 bup is a backup tool which stores the backups in a system based around
 the packfile format from git.
 .
 This package contains the documentation.

## bup 0.32

=== Makefile ===
--- 
+++ 
@@ -19,16 +19,17 @@
 $(if $(subst ok,,$(lastword $(1))),$(error $(2)),$(shell x="$(1)"; echo $${x%???}))
 endef
 
-sampledata_rev := $(shell t/configure-sampledata --revision $(isok))
+sampledata_rev := $(shell dev/configure-sampledata --revision $(isok))
 sampledata_rev := \
   $(call shout,$(sampledata_rev),Could not parse sampledata revision)
 
-current_sampledata := t/sampledata/var/rev/v$(sampledata_rev)
+current_sampledata := test/sampledata/var/rev/v$(sampledata_rev)
 
 os := $(shell ($(pf); uname | sed 's/[-_].*//') $(isok))
 os := $(call shout,$(os),Unable to determine OS)
 
-CFLAGS := -Wall -Wformat=2 -O2 -Werror -Wno-unknown-pragmas $(CFLAGS)
+CFLAGS := -O2 -Wall -Werror -Wformat=2 $(CFLAGS)
+CFLAGS := -Wno-unknown-pragmas -Wsign-compare $(CFLAGS)
 CFLAGS := -D_FILE_OFFSET_BITS=64 $(PYINCLUDE) $(CFLAGS)
 SOEXT:=.so
 
@@ -39,7 +40,7 @@
 ifdef TMPDIR
   test_tmp := $(TMPDIR)
 else
-  test_tmp := $(CURDIR)/t/tmp
+  test_tmp := $(CURDIR)/test/tmp
 endif
 
 initial_setup := $(shell dev/update-checkout-info lib/bup/checkout_info.py $(isok))
@@ -81,7 +82,7 @@
 all: $(bup_deps) Documentation/all $(current_sampledata)
 
 $(current_sampledata):
-	t/configure-sampledata --setup
+	dev/configure-sampledata --setup
 
 PANDOC ?= $(shell type -p pandoc)
 
@@ -155,114 +156,29 @@
 	  "import glob; assert(len(glob.glob('lib/bup/build/*/_helpers*$(SOEXT)')) == 1)"
 	cp lib/bup/build/*/_helpers*$(SOEXT) "$@"
 
-t/tmp:
-	mkdir t/tmp
-
-runtests: runtests-python runtests-cmdline
-
-python_tests := \
-  lib/bup/t/tbloom.py \
-  lib/bup/t/tclient.py \
-  lib/bup/t/tgit.py \
-  lib/bup/t/thashsplit.py \
-  lib/bup/t/thelpers.py \
-  lib/bup/t/tindex.py \
-  lib/bup/t/tmetadata.py \
-  lib/bup/t/toptions.py \
-  lib/bup/t/tresolve.py \
-  lib/bup/t/tshquote.py \
-  lib/bup/t/tvfs.py \
-  lib/bup/t/tvint.py \
-  lib/bup/t/txstat.py
-
-# The "pwd -P" here may not be appropriate in the long run, but we
-# need it until we settle the relevant drecurse/exclusion questions:
-# https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
-runtests-python: all t/tmp
-	mkdir -p t/tmp/test-log
-	$(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
-	  ./wvtest.py  $(python_tests) 2>&1 \
-	    | tee -a t/tmp/test-log/$$$$.log
-
-cmdline_tests := \
-  t/test-help \
-  t/test.sh \
-  t/test-argv \
-  t/test-cat-file.sh \
-  t/test-command-without-init-fails.sh \
-  t/test-compression.sh \
-  t/test-drecurse.sh \
-  t/test-fsck.sh \
-  t/test-fuse.sh \
-  t/test-ftp \
-  t/test-web.sh \
-  t/test-gc.sh \
-  t/test-import-duplicity.sh \
-  t/test-import-rdiff-backup.sh \
-  t/test-index.sh \
-  t/test-index-check-device.sh \
-  t/test-index-clear.sh \
-  t/test-list-idx.sh \
-  t/test-ls \
-  t/test-ls-remote \
-  t/test-main.sh \
-  t/test-meta.sh \
-  t/test-on.sh \
-  t/test-packsizelimit \
-  t/test-prune-older \
-  t/test-redundant-saves.sh \
-  t/test-restore-map-owner.sh \
-  t/test-restore-single-file.sh \
-  t/test-rm.sh \
-  t/test-rm-between-index-and-save.sh \
-  t/test-save-creates-no-unrefs.sh \
-  t/test-save-restore \
-  t/test-save-errors \
-  t/test-save-restore-excludes.sh \
-  t/test-save-strip-graft.sh \
-  t/test-save-with-valid-parent.sh \
-  t/test-sparse-files.sh \
-  t/test-split-join.sh \
-  t/test-tz.sh \
-  t/test-xdev.sh
-
-tmp-target-run-test-get-%: all t/tmp
-	$(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
-	  t/test-get $* 2>&1 | tee -a t/tmp/test-log/$$$$.log
-
-test_get_targets += \
-  tmp-target-run-test-get-replace \
-  tmp-target-run-test-get-universal \
-  tmp-target-run-test-get-ff \
-  tmp-target-run-test-get-append \
-  tmp-target-run-test-get-pick \
-  tmp-target-run-test-get-new-tag \
-  tmp-target-run-test-get-unnamed
-
-# For parallel runs.
-# The "pwd -P" here may not be appropriate in the long run, but we
-# need it until we settle the relevant drecurse/exclusion questions:
-# https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
-tmp-target-run-test%: all t/tmp
-	$(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
-	  t/test$* 2>&1 | tee -a t/tmp/test-log/$$$$.log
-
-runtests-cmdline: $(test_get_targets) $(subst t/test,tmp-target-run-test,$(cmdline_tests))
+test/tmp:
+	mkdir test/tmp
+
+ifeq (yes,$(shell config/bin/python -c "import xdist; print('yes')" 2>/dev/null))
+  # MAKEFLAGS must not be in an immediate := assignment
+  parallel_opt = $(lastword $(filter -j%,$(MAKEFLAGS)))
+  get_parallel_n = $(patsubst -j%,%,$(parallel_opt))
+  maybe_specific_n = $(if $(filter -j%,$(parallel_opt)),-n$(get_parallel_n))
+  xdist_opt = $(if $(filter -j,$(parallel_opt)),-nauto,$(maybe_specific_n))
+else
+  xdist_opt =
+endif
+
+test: all test/tmp
+	./pytest $(xdist_opt)
 
 stupid:
 	PATH=/bin:/usr/bin $(MAKE) test
 
-test: all
-	if test -e t/tmp/test-log; then rm -r t/tmp/test-log; fi
-	mkdir -p t/tmp/test-log
-	./wvtest watch --no-counts \
-	  $(MAKE) runtests 2>t/tmp/test-log/$$$$.log
-	./wvtest report t/tmp/test-log/*.log
-
 check: test
 
 distcheck: all
-	./wvtest run t/test-release-archive.sh
+	./pytest $(xdist_opt) -m release
 
 long-test: export BUP_TEST_LEVEL=11
 long-test: test
@@ -328,18 +244,18 @@
 		*.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
 		lib/bup/checkout_info.py \
 		randomgen memtest \
-		testfs.img lib/bup/t/testfs.img
+		testfs.img test/int/testfs.img
 	for x in $$(ls cmd/*-cmd.py cmd/*-cmd.sh | grep -vF python-cmd.sh | cut -b 5-); do \
 	    echo "cmd/bup-$${x%-cmd.*}"; \
 	done | xargs -t rm -f
-	if test -e t/mnt; then t/cleanup-mounts-under t/mnt; fi
-	if test -e t/mnt; then rm -r t/mnt; fi
-	if test -e t/tmp; then t/cleanup-mounts-under t/tmp; fi
-        # FIXME: migrate these to t/mnt/
-	if test -e lib/bup/t/testfs; \
-	  then umount lib/bup/t/testfs || true; fi
-	rm -rf *.tmp *.tmp.meta t/*.tmp lib/*/*/*.tmp build lib/bup/build lib/bup/t/testfs
-	if test -e t/tmp; then t/force-delete t/tmp; fi
-	t/configure-sampledata --clean
+	if test -e test/mnt; then dev/cleanup-mounts-under test/mnt; fi
+	if test -e test/mnt; then rm -r test/mnt; fi
+	if test -e test/tmp; then dev/cleanup-mounts-under test/tmp; fi
+        # FIXME: migrate these to test/mnt/
+	if test -e test/int/testfs; \
+	  then umount test/int/testfs || true; fi
+	rm -rf *.tmp *.tmp.meta test/*.tmp lib/*/*/*.tmp build lib/bup/build test/int/testfs
+	if test -e test/tmp; then dev/force-delete test/tmp; fi
+	dev/configure-sampledata --clean
         # Remove last so that cleanup tools can depend on it
 	rm -rf config/bin

=== debian/changelog ===
bup (0.32-3) unstable; urgency=medium

  * debian/watch: Add watch file
  * debian/control: Drop python3-pytest-xdist build dependency (don't run
    tests in parallel)

 -- Robert Edmonds <edmonds@debian.org>  Sat, 06 Feb 2021 15:18:16 -0500

bup (0.32-2) unstable; urgency=medium

  * Upload to unstable.

 -- Robert Edmonds <edmonds@debian.org>  Sun, 31 Jan 2021 16:04:39 -0500

bup (0.32-1) experimental; urgency=medium

  * New upstream version 0.32

 -- Robert Edmonds <edmonds@debian.org>  Sat, 30 Jan 2021 21:50:17 -0500

bup (0.32~git20201223-1) experimental; urgency=medium

  * New upstream git snapshot of commit
    b8e90ee2882c7b93d6c8c8fb1ef4cc6ed00aa2b3 due to call for testing
  * debian/control: Add new build dependencies python3-pytest,
    python3-pytest-xdist

 -- Robert Edmonds <edmonds@debian.org>  Mon, 28 Dec 2020 21:10:27 -0500

bup (0.31-2) unstable; urgency=medium

  * lib/bup/_helpers.c: Disable the code that calls Py_GetArgcArgv()
    (Closes: #972763)

 -- Robert Edmonds <edmonds@debian.org>  Sat, 31 Oct 2020 15:26:24 -0400

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,7 @@
  par2 [!hurd-i386],
  python3-dev,
  python3-pylibacl,
+ python3-pytest,
  python3-pyxattr [linux-any],
  rsync,
  tzdata,

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python3

override_dh_auto_configure:
	PYTHON="python3" ./configure

override_dh_auto_build-indep:
	$(MAKE) Documentation/all

override_dh_auto_clean:
	-rm config/config.cmd config/config.h config/config.log config/config.mak config/config.md config/config.sub config/config.vars
	dh_auto_clean -- PYTHON="python3"

override_dh_auto_install:
	$(CURDIR)/debian/gen_checkout_info.sh > $(CURDIR)/lib/bup/checkout_info.py
	$(MAKE) PYTHON="python3" PREFIX="/usr" DESTDIR="$(CURDIR)/debian/tmp" install

override_dh_python3:
	dh_python3 -X /usr/lib/bup/bup/py2raise.py

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/bup-$1\.tar\.gz/ \
  https://github.com/bup/bup/releases .*/v?(\d\S+)\.tar\.gz

## bup 0.33

=== debian/changelog ===
bup (0.33-2) unstable; urgency=medium

  * Upload to unstable.

 -- Robert Edmonds <edmonds@debian.org>  Mon, 26 Dec 2022 22:27:53 -0500

bup (0.33-1) experimental; urgency=medium

  [ Rob Browning ]
  * debian/watch: releases is broken; switch to git mode
  * Make some initial changes for 0.33

  [ Robert Edmonds ]
  * New upstream version 0.33
  * debian/rules: Use DEB_CFLAGS_MAINT_APPEND to pass -Wno-error to
    ./configure
  * Revert "rules: override dh_auto_clean, rm files from configure."
  * debian/control: Bump Standards-Version to 4.6.2 (no changes)
  * debian/control: Remove version constraint for pandoc dependencies
    (o-o-stable has 1.17.2~dfsg-3)
  * debian/control: Set "Rules-Requires-Root: binary-targets"
  * debian/rules: Set DEB_BUILD_MAINT_OPTIONS to enable 'hardening=+all'
  * debian/bup.lintian-overrides: Override no-manual-page usr/bin/bup
  * debian/bup-doc.lintian-overrides: Override spare-manual-page
  * debian/control: Add Vcs-Git, Vcs-Browser for new salsa repository
  * debian/README.source: Remove collab-maint note, add note about Debian
    branches

 -- Robert Edmonds <edmonds@debian.org>  Thu, 22 Dec 2022 20:04:49 -0500

## bup 0.33.2

=== debian/changelog ===
bup (0.33.2-1~deb12u1) bookworm; urgency=medium

  * Upstream version 0.33.2, with a fix for a problem that can cause POSIX.1e
    ACLs to be restored incorrectly.

 -- Robert Edmonds <edmonds@debian.org>  Sat, 08 Jul 2023 16:11:59 -0400

bup (0.33.2-1) unstable; urgency=medium

  [ Rob Browning ]
  * 0.33.2
    - Update base_version for 0.33.2 development
    - correct_posix1e_v1_delimiters: provide path for error messages
      (Closes: #1039089)
    - Update docs for 0.33.2 release
    - Update base_version for 0.33.2 release

  [ Robert Edmonds ]
  * New upstream version 0.33.2
  * debian/docs: Include upstream release note '0.33.2-from-0.33.1.md'

 -- Robert Edmonds <edmonds@debian.org>  Sat, 01 Jul 2023 18:51:02 -0400

bup (0.33.1-1) unstable; urgency=medium

  [ Rob Browning ]
  * 0.33.1
    - conftest.py: switch to Path to support pytest 7+
    - conftest.py: restore support for pytest < 7
    - configure: handle relative MAKE paths
    - test_get: remove vestigial debug messages
    - configure: allow and prefer python3.11-config; ignore 3.6
    - buptest init: get quote from shlex not pipes
    - test-comparative-split-join: accommodate varying HEAD names
    - cirrus: move to freebsd 12.4 to fix rsync-related test failures
    - compare-trees: add --features and disallow args with it and -h
    - Restore posix1e default acls as default, not access; improve tests
    - Fix ACL metadata format; delimit short form entries with commas
    - Update docs for 0.33.1 release
    - Update base_version for 0.33.1 release

  [ Robert Edmonds ]
  * New upstream version 0.33.1 (Closes: #1038609)
  * debian/docs: Include upstream release note '0.33.1-from-0.33.md'

 -- Robert Edmonds <edmonds@debian.org>  Sun, 18 Jun 2023 19:57:44 -0400

## bup 0.33.3

=== debian/changelog ===
bup (0.33.3-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:43:59 +0000

bup (0.33.3-1build1) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:08:25 +0100

bup (0.33.3-1) unstable; urgency=medium

  * New upstream version 0.33.3
    - "fuse: don't filter output when backgrounding" (Closes: #1050040)
    - "test-help: fix dependency on C locale with current pandoc" (Closes:
    #1042250)
  * debian/docs: Include upstream release note '0.33.3-from-0.33.2.md'

 -- Robert Edmonds <edmonds@debian.org>  Sat, 27 Jan 2024 00:12:36 -0500

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,11 @@
 Source: bup
 Section: admin
 Priority: optional
-Maintainer: Robert Edmonds <edmonds@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Robert Edmonds <edmonds@debian.org>
 Build-Depends:
  acl,
+ attr,
  dctrl-tools,
  debhelper-compat (= 13),
  dh-python,
@@ -11,15 +13,20 @@
  libacl1-dev,
  libreadline-dev,
  par2 [!hurd-i386],
+ pkg-config,
  python3-dev,
  python3-pylibacl,
  python3-pytest,
+ python3-pytest-xdist,
  python3-pyxattr [linux-any],
  rsync,
  tzdata,
-Build-Depends-Indep: pandoc (>= 1.11.1-4~), pandoc-data (>= 1.11.1-4~)
-Standards-Version: 4.5.0
+Build-Depends-Indep: pandoc, pandoc-data
+Standards-Version: 4.6.2
 Homepage: https://github.com/bup/bup
+Vcs-Git: https://salsa.debian.org/edmonds/bup.git
+Vcs-Browser: https://salsa.debian.org/edmonds/bup
+Rules-Requires-Root: binary-targets
 
 Package: bup
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export BUP_PYTHON_CONFIG := python3-config
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND := -Wno-error

%:
	dh $@ --with python3

override_dh_auto_configure:
	./configure

override_dh_auto_build-indep:
	$(MAKE) Documentation/all

override_dh_auto_install:
	$(CURDIR)/debian/gen_checkout_info.sh > $(CURDIR)/lib/bup/checkout_info.py
	$(MAKE) PREFIX="/usr" DESTDIR="$(CURDIR)/debian/tmp" install

## bup 0.33.4

=== debian/changelog ===
bup (0.33.4-1) unstable; urgency=medium

  * New upstream version 0.33.4
    - "configure.inc: fix main() prototype and other (now) invalid test code"
    (Closes: #1074858)
  * debian/docs: Include upstream release note '0.33.4-from-0.33.3.md'

 -- Robert Edmonds <edmonds@debian.org>  Sun, 29 Sep 2024 15:41:36 -0400

## bup 0.33.6~git20241212

=== debian/changelog ===
bup (0.33.6~git20241212-1build1) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 12:05:18 +0100

bup (0.33.6~git20241212-1) unstable; urgency=medium

  [ Rob Browning ]
  * debian/rules: Generate checkout info prior to dh_auto_configure

  [ Robert Edmonds ]
  * New upstream git snapshot of commit 3cd11d3840b0714820ca5fc540115a339d1ee7fa
    due to call for testing
  * debian/docs: Include upstream release note '0.33.5-from-0.33.4.md'
  * Revert "debian/rules: Relocate bup-config.5 to the correct manpage
    directory" (fixed upstream)

 -- Robert Edmonds <edmonds@debian.org>  Sat, 14 Dec 2024 22:24:03 -0500

bup (0.33.5-1) unstable; urgency=medium

  * New upstream version 0.33.5
    - Bug fixes for "three issues that could cause a repository to end up
      with trees that had dangling references, i.e. missing files, parts of
      files, subtrees, etc." if the "bup gc" command is utilized.
      (Closes: #1086123)
  * debian/rules: Relocate bup-config.5 to the correct manpage directory

 -- Robert Edmonds <edmonds@debian.org>  Wed, 11 Dec 2024 23:38:00 -0500

## bup 0.33.7

=== Makefile ===

# Redirect to GNU make

.SUFFIXES:

default: config/finished
	config/bin/make

.DEFAULT:
	$(MAKE) config/finished
	config/bin/make $(.TARGETS)

# Dependency changes here should be mirrored in GNUmakefile
config/finished: configure config/configure config/configure.inc config/*.in
	MAKE= ./configure

=== debian/changelog ===
bup (0.33.7-1) unstable; urgency=medium

  * New upstream versions 0.33.6, 0.33.7
  * debian/docs: Include upstream release note '0.33.6-from-0.33.5.md'
  * debian/docs: Include upstream release note '0.33.7-from-0.33.6.md'

 -- Robert Edmonds <edmonds@debian.org>  Sat, 11 Jan 2025 16:41:56 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: bup
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Robert Edmonds <edmonds@debian.org>
+Maintainer: Robert Edmonds <edmonds@debian.org>
 Build-Depends:
  acl,
  attr,

## bup 0.33.9

=== debian/changelog ===
bup (0.33.9-1) unstable; urgency=medium

  * New upstream versions 0.33.8, 0.33.9
  * debian/docs: Include upstream release note '0.33.8-from-0.33.7.md'
  * debian/docs: Include upstream release note '0.33.9-from-0.33.8.md'

 -- Robert Edmonds <edmonds@debian.org>  Mon, 01 Sep 2025 22:50:50 -0400

=== debian/rules ===
--- 
+++ 
@@ -7,12 +7,14 @@
 %:
 	dh $@ --with python3
 
-override_dh_auto_configure:
+lib/bup/checkout_info.py: debian/gen_checkout_info.sh
+	debian/gen_checkout_info.sh > $@
+
+override_dh_auto_configure: lib/bup/checkout_info.py
 	./configure
 
 override_dh_auto_build-indep:
 	$(MAKE) Documentation/all
 
 override_dh_auto_install:
-	$(CURDIR)/debian/gen_checkout_info.sh > $(CURDIR)/lib/bup/checkout_info.py
 	$(MAKE) PREFIX="/usr" DESTDIR="$(CURDIR)/debian/tmp" install

=== debian/watch ===
version=4
opts="mode=git" \
https://github.com/bup/bup.git \
refs/tags/(\d+(?:\.\d+)+)

## bup 0.33.10

=== debian/changelog ===
bup (0.33.10-1) unstable; urgency=medium

  * New upstream version 0.33.10
  * debian/docs: Include upstream release note '0.33.10-from-0.33.9.md'

 -- Robert Edmonds <edmonds@debian.org>  Mon, 02 Mar 2026 21:39:56 -0500

bup (0.33.9-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop Rules-Requires-Root: binary-targets (Closes: #1111625)

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 18 Nov 2025 08:46:05 +0100

bup (0.33.9-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Skip test tries to load a kernel module (Closes #1111625)

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 06 Nov 2025 19:13:01 +0100
